<?php
function outputHtml( $shmid, $rpos, $tpos, $wData, $cData, $wDataMst, $cDataMst ) {
global $CARS_MAX, $TYRES, $TRACKS, $SESSION_TYPE, $FUEL_MIX, $FC_BASE, $FC_MULTI, $FUEL_MIX_MULTI, $LAPTIME_MAX ;

$tr_class = array( "even","odd" ) ;
$era = $wData["m_era"] ;
$flags = $wData["m_vehicleFIAFlags"] ;
$st = $wData["m_sessionType"] ;
$track = $TRACKS[$wData["m_track_number"]] ;
$ts = $wData["m_track_size"] ;
$tln = $wData["m_total_laps"] ;
$drs = $wData["m_drsAllowed"] | $wData["m_drs"] ;
$cln = 1 ;
$pci = $wData["m_player_car_index"] ;

foreach( $rpos as $i => $v ) {
  $leader_idx = $i ;
  break ;
}

if( $st != 3 ) {
  $cln = $cData[$pci]["m_currentLapNum"] ;
} else {
  foreach( $rpos as $i => $v ) {
    $cln = $cData[$i]["m_currentLapNum"] ;
    break ;
  }
}

switch( $st ) {
  case 3:
    $lbgap = "Interval" ;
    $rt = 0 ;
    if( $cln > 1 ) {
      $rt = getRaceTime( $cDataMst[$pci]["m_lapTime"] ) ;
    }
    if( $cln <= $tln ) {
      $rt += $cData[$pci]["m_currentLapTime"] ;
    }
    break ;
  default:
    $lbgap = "Gap" ;
    $rt = $wData["m_session_time_left"] ;
    break ;
}
ob_start();
?>
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8">
  <meta http-equiv="Pragma" content="no-cache">
  <meta http-equiv="Cache-Control" content="no-store">
  <meta http-equiv="Cache-Control" content="no-cache">
  <meta http-equiv="Expires" content="-1">
  <link rel="stylesheet" type="text/css" href="common.css">
  <title><?php echo microtime();?></title>
</head>
<body>
  <!-- race timing -->
  <table class="racetiming" border="1">
    <tr align="left">
      <td colspan="7" align="left" class="flag<?php echo $flags; ?>"><?php echo $track; ?></td>
      <td colspan="1" align="right"><?php printf( "%d", $ts ) ; ?>m</td>
      <td colspan="2" align="left"><?php echo $SESSION_TYPE[$st] ; ?></td>
      <td colspan="2" align="right" class="time"><?php echo outputTime($rt, 0); ?></td>
      <td colspan="3" align="right">L <?php echo $cln; ?> / <?php echo $tln; ?></td>
    </tr>
    <tr align="left">
      <th colspan="2" class="d2">Pos</th>
      <th>Driver</th>
      <th colspan="2">Lap</th>
      <th class="time">Last</th>
      <th class="time">Best</th>
      <th class="time"><?php echo $lbgap; ?></th>
      <th class="time">Sector1</th>
      <th class="time">Sector2</th>
      <th class="time">Sector3</th>
      <th class="d2">Tyre</th>
      <th colspan="2" class="d2">Pit</th>
      <th class="d2">Pen</th>
    </tr>
<?php
$lc = 0 ;
foreach( $rpos as $i => $v ) {
  $cd1 = $cData[$i] ;
  $cdm1 = $cDataMst[$i] ;
  $teamid = $cd1["m_teamId"] ;
  $cln = $cd1["m_currentLapNum"] ;
  $sn = $cd1["m_sector"] ;
  $gap = $cdm1["m_interval"] ;
  $lapc = floor( $cd1["m_lapDistance"] / $wData["m_track_size"] * 100 ) ;
  $tyre = $cd1["m_tyreCompound"] ;
  $isPlayer = "other" ;
  $inPits = $cd1["m_inPits"] ;
  $stops = $cdm1["m_pitStops"] ;
  $pitlaps = $cdm1["m_pitLaps"] ;
  $pen = $cd1["m_penalties"] ;
  $poschg = $cdm1["m_carPosition"][0] - $cd1["m_carPosition"] ;
  $poschg_flag = 0 ;
  if( $poschg > 0 ) {
    $poschg_flag = 1 ;
    $poschg = sprintf( "+%d", $poschg ) ;
  }
  if( $poschg == 0 ) {
    $poschg_flag = 2 ;
  }
  if( $i == $pci ) {
    $isPlayer = "player" ;
  }

  switch( $sn+1 ) {
    case 1:
      $s1t = getSectorTime( $cdm1, ($cln-1), "m_sector1Time") ;
      $s2t = getSectorTime( $cdm1, ($cln-1), "m_sector2Time") ;
      $s3t = getSectorTime( $cdm1, ($cln-1), "m_sector3Time") ;
      break ;
    default:
      $s1t = getSectorTime( $cdm1, $cln, "m_sector1Time") ;
      $s2t = getSectorTime( $cdm1, $cln, "m_sector2Time") ;
      $s3t = getSectorTime( $cdm1, $cln, "m_sector3Time") ;
      break ;
  }
  $llt = $cd1["m_lastLapTime"] ;
  $blt = $cd1["m_bestLapTime"] ;
  $c_llt = checkBestTime( $llt, "m_bestLapTime", $wDataMst, $cdm1 ) ;

  $c_blt = checkBestTime( $blt, "m_bestLapTime", $wDataMst, $cdm1 ) ;
  $c_s1t = checkBestTime( $s1t, "m_bestSector1Time", $wDataMst, $cdm1 ) ;
  $c_s2t = checkBestTime( $s2t, "m_bestSector2Time", $wDataMst, $cdm1 ) ;
  $c_s3t = checkBestTime( $s3t, "m_bestSector3Time", $wDataMst, $cdm1 ) ;
  $cli = 0 ;
  if( $sn == 0 ) {
    if( $cln > 2 ) {
      $cli = getArray( $cdm1["m_currentLapInvalid"], $cln-2 ) ;
    }
  } else {
    $cli = getArray( $cdm1["m_currentLapInvalid"], $cln-1 ) ;
  }
?>
    <tr align="right" class="<?php echo $tr_class[$v%2]; ?> <?php echo $isPlayer; ?>">
      <td class="d2"><?php echo $cd1["m_carPosition"]; ?></td>
      <td class="d2 pos<?php echo $poschg_flag; ?>"><?php echo $poschg; ?></td>
      <td class="driver team<?php echo $teamid; ?>_<?php echo $era; ?>" align="left"><?php echo $cdm1["m_driverNameShort"]; ?></td>
      <td class="d2"><?php echo $cln; ?></td>
      <td class="d3"><?php echo $lapc; ?>%</td>
      <td class="time cli<?php echo $cli; ?> <?php echo $c_llt; ?>"><?php outputTime($llt, 0); ?></td>
      <td class="time <?php echo $c_blt; ?>"><?php outputTime($blt, 0); ?></td>
      <td class="time"><?php outputTime($gap, 1); ?></td>
      <td class="time <?php echo $c_s1t; ?>"><?php outputTime($s1t, 0); ?></td>
      <td class="time <?php echo $c_s2t; ?>"><?php outputTime($s2t, 0); ?></td>
      <td class="time <?php echo $c_s3t; ?>"><?php outputTime($s3t, 0); ?></td>
      <td class="tyre<?php echo $tyre; ?>" align="center"><?php echo $TYRES[$tyre]; ?></td>
      <td class="d2 inpits<?php echo $inPits; ?>"><?php echo $stops; ?></td>
      <td class="d3"><?php if($pitlaps>0) printf("L%2d", $pitlaps); ?></td>
      <td class="d2"><?php echo $pen; ?></td>
    </tr>
<?php
  $lc++ ;
}
for( $i=$lc+1 ; $i<$CARS_MAX+1 ; $i++ ) {
?>
    <tr align="right" class="<?php echo $tr_class[$i%2]; ?>">
      <td colspan="15" align="left">-</td>
    </tr>
<?php
}
?>
  </table>

  <!-- track position -->
  <table class="trackposition" border="1">
    <tr>
      <th colspan="3" class="title">Track Position</th>
    </tr>
    <tr>
      <th>Pos</th>
      <th>Driver</th>
      <th>Dist</th>
    </tr>
<?php
$lc = 0 ;
if( sizeof($tpos) > 0 ) {
  $tmp = array_keys( $tpos ) ;
  $idx_last = end( $tmp ) ;
  $ldf = $tpos[$idx_last] ;
  foreach( $tpos as $i => $ld ) {
    $cd1 = $cData[$i] ;
    $cdm1 = $cDataMst[$i] ;
    $teamid = $cd1["m_teamId"] ;
    $ldi = floor( ($ldf<$ld) ? $ts + $ldf - $ld : $ldf - $ld ) ;
    $inPits = $cd1["m_inPits"] ;
    $isPlayer = "other" ;
    if( $i == $pci ) {
      $isPlayer = "player" ;
    }
?>
    <tr align="right" class="<?php echo $isPlayer; ?>">
      <td class="d2 inpits<?php echo $inPits; ?>" align="right"><?php echo $cd1["m_carPosition"]; ?></td>
      <td class="driver team<?php echo $teamid; ?>_<?php echo $era; ?>" align="left"><?php echo $cdm1["m_driverNameShort"]; ?></td>
      <td class="d4" align="right"><?php echo $ldi; ?>m</td>
    </tr>
<?php
    $ldf = $ld ;
    $lc++ ;
  }
}
for( $i=$lc+1 ; $i<$CARS_MAX+1 ; $i++ ) {
?>
    <tr align="right">
      <td colspan="3" align="left">-</td>
    </tr>
<?php
}
?>
  </table>
  <hr />
<?php
$ts = $wData["m_track_size"] ;
$tln = $wData["m_total_laps"] ;
$pci = $wData["m_player_car_index"] ;
$cln = $cData[$pci]["m_currentLapNum"] ;
$ld = $cData[$pci]["m_lapDistance"] ;
$dist = $ts * ($cln-1) + $ld ; // total distance
$rl = ($tln - $cln + 1) - ($ld / $ts) ;
$ty_w = $wData["m_tyres_wear"] ;
$ty_t = $wData["m_tyres_temperature"] ;
$ty_p = $wData["m_tyres_pressure"] ;
$ty_d = $wData["m_tyres_damage"] ;
$br_t = $wData["m_brakes_temp"] ;
$fbb = $wData["m_front_brake_bias"] ;
$flwc = 100 - $wData["m_front_left_wing_damage"] ;
$frwc = 100 - $wData["m_front_right_wing_damage"] ;
$rwc = 100 - $wData["m_rear_wing_damage"] ;
$fm = $wData["m_fuel_mix"] ;
$fit = $wData["m_fuel_in_tank"] ;
$fu = $wDataMst["m_fuelUse"][$fm] ;
$td = $wDataMst["m_fuelDistance"][$fm] ;
$fus = $wDataMst["m_fuelUse"][1] ;
$tds = $wDataMst["m_fuelDistance"][1] ;
$fll = $rl ;
$flls = $rl ;
$ft = 0 ;
$fpl = $ts / $FC_BASE ;
if( $fu > 0 ) {
  $fpl = $ts / (($td + $FC_BASE * $FC_MULTI) / ($fu + $FC_MULTI * $FUEL_MIX_MULTI[$fm] )) ;
  $fpls = $ts / (($tds + $FC_BASE * $FC_MULTI) / ($fus + $FC_MULTI * $FUEL_MIX_MULTI[1] )) ;
  $fll = $fit / $fpl ;
  $flls = $fit / $fpls ;
} ;
if( $st == 3 ) {
  $ft = $flls - $rl ;
}
$sft = sprintf( "%.2f", $ft ) ;
if( $ft >= 0 ) {
  $sft = '+' . $sft ;
}
?>
  <!-- player data -->
  <table class="playerdata" border="1">
    <tr>
      <th colspan="4" class="title">Tyre</th>
      <th colspan="1" class="title">Brake</th>
      <th colspan="1" class="title">Wing</th>
      <th colspan="2" class="title">Fuel</th>
    </tr>
    <tr>
      <th class="d2">FL</th>
      <td class="d4" align="right"><?php printf("%.1f", $ty_p[0]); ?>PSI</td>
      <td class="d3" align="right"><?php printf("%3d", $ty_w[0]); ?>%</td>
      <td class="d3" align="right"><?php printf("%3d", $ty_t[0]); ?>C</td>
      <td class="d3" align="right"><?php printf("%4d", $br_t[0]); ?>C</td>
      <td class="d3" align="right"><?php printf("%3d", $flwc); ?>%</td>
      <th class="d2">Mix</th>
      <td class="d5" align="right"><?php echo $FUEL_MIX[$fm]; ?></td>
    </tr>
    <tr>
      <th class="d2">FR</th>
      <td class="d4" align="right"><?php printf("%.1f", $ty_p[1]); ?>PSI</td>
      <td class="d3" align="right"><?php printf("%3d", $ty_w[1]); ?>%</td>
      <td class="d3" align="right"><?php printf("%3d", $ty_t[1]); ?>C</td>
      <td class="d3" align="right"><?php printf("%4d", $br_t[1]); ?>C</td>
      <td class="d3" align="right"><?php printf("%3d", $frwc); ?>%</td>
      <th class="d2">left</th>
      <td class="d5" align="right"><?php printf("%.2f", $fit); ?>kg</td>
    </tr>
    <tr>
      <th class="d2">RL</th>
      <td class="d4" align="right"><?php printf("%.1f", $ty_p[2]); ?>PSI</td>
      <td class="d3" align="right"><?php printf("%3d", $ty_w[2]); ?>%</td>
      <td class="d3" align="right"><?php printf("%3d", $ty_t[2]); ?>C</td>
      <td class="d3" align="right"><?php printf("%4d", $br_t[2]); ?>C</td>
      <td rowspan="2" class="d3" align="right"><?php printf("%3d", $rwc); ?>%</td>
      <th class="d2">kg/L</th>
      <td class="d5" align="right"><?php printf("%.2f", $fpl); ?></td>
    </tr>
    <tr>
      <th class="d2">RR</th>
      <td class="d4" align="right"><?php printf("%.1f", $ty_p[3]); ?>PSI</td>
      <td class="d3" align="right"><?php printf("%3d", $ty_w[3]); ?>%</td>
      <td class="d3" align="right"><?php printf("%3d", $ty_t[3]); ?>C</td>
      <td class="d3" align="right"><?php printf("%4d", $br_t[3]); ?>C</td>
      <th class="d2">laps</th>
      <td class="d5" align="right"><?php printf("%.2f", $fll); ?></td>
    </tr>
    <tr>
      <td colspan="4" align="right">Front Brake Bias</td>
      <td class="d3" align="right"><?php echo $fbb ; ?>%</td>
      <td class="d3 drs<?php echo $drs; ?>" align="center">DRS</td>
      <th class="d2">tgt</th>
      <td class="d5 fuel<?php echo ($ft>=0) ? 0 : 1; ?>" align="right"><?php echo $sft; ?></td>
    </tr>
  </table>
  <!-- fastest data -->
  <table class="fastests" border="1">
    <tr>
      <th colspan="5" class="title">Fastests</th>
    </tr>
    <tr>
      <th>Lap</th>
      <td class="driver team<?php echo $wDataMst["m_bestLapTimeTID"]; ?>_<?php echo $era; ?>" align="left"><?php echo $wDataMst["m_bestLapTimeDNS"]; ?></td>
      <td class="time" align="right"><?php outputTime($wDataMst["m_bestLapTime"], 0); ?></td>
      <td class="d3" align="right"><?php printf("L%2d", $wDataMst["m_bestLapTimeL"]); ?></td>
      <td class="tyre<?php echo $wDataMst["m_bestLapTimeTC"]; ?>" align="center"><?php echo $TYRES[$wDataMst["m_bestLapTimeTC"]]; ?></td>
    </tr>
    <tr>
      <th>S1</th>
      <td class="driver team<?php echo $wDataMst["m_bestSector1TimeTID"]; ?>_<?php echo $era; ?>" align="left"><?php echo $wDataMst["m_bestSector1TimeDNS"]; ?></td>
      <td class="time" align="right"><?php outputTime($wDataMst["m_bestSector1Time"], 0); ?></td>
      <td class="d3" align="right"><?php printf("L%2d", $wDataMst["m_bestSector1TimeL"]); ?></td>
      <td class="tyre<?php echo $wDataMst["m_bestSector1TimeTC"]; ?>" align="center"><?php echo $TYRES[$wDataMst["m_bestSector1TimeTC"]]; ?></td>
    </tr>
    <tr>
      <th>S2</th>
      <td class="driver team<?php echo $wDataMst["m_bestSector2TimeTID"]; ?>_<?php echo $era; ?>" align="left"><?php echo $wDataMst["m_bestSector2TimeDNS"]; ?></td>
      <td class="time" align="right"><?php outputTime($wDataMst["m_bestSector2Time"], 0); ?></td>
      <td class="d3" align="right"><?php printf("L%2d", $wDataMst["m_bestSector2TimeL"]); ?></td>
      <td class="tyre<?php echo $wDataMst["m_bestSector2TimeTC"]; ?>" align="center"><?php echo $TYRES[$wDataMst["m_bestSector2TimeTC"]]; ?></td>
    </tr>
    <tr>
      <th>S3</th>
      <td class="driver team<?php echo $wDataMst["m_bestSector3TimeTID"]; ?>_<?php echo $era; ?>" align="left"><?php echo $wDataMst["m_bestSector3TimeDNS"]; ?></td>
      <td class="time" align="right"><?php outputTime($wDataMst["m_bestSector3Time"], 0); ?></td>
      <td class="d3" align="right"><?php printf("L%2d", $wDataMst["m_bestSector3TimeL"]); ?></td>
      <td class="tyre<?php echo $wDataMst["m_bestSector3TimeTC"]; ?>" align="center"><?php echo $TYRES[$wDataMst["m_bestSector3TimeTC"]]; ?></td>
    </tr>
  </table>
  <br />
<!--
  Pos: Position / Change, Lap: Current Laps / Track Position, Pit: Stops / Last Stop, PN: Additional Times by the Penalties<br />
-->
</body>
</html>
<!-- end -->
<?php
//file_put_contents( '../data.html', ob_get_contents(), LOCK_EX ) ;
$html = ob_get_contents() ;
ob_end_clean() ;
shmop_write( $shmid, $html, 0 ) ;
}
?>
